import getScrollParent from "./getScrollParent.js";
import getOffsetParent from "./getOffsetParent.js";
import getParentNode from "./getParentNode.js";
import getWindow from "./getWindow.js";
import getDocumentElement from "./getDocumentElement.js"; // A "clipping parent" is a scrolling container with the characteristic of
// clipping (or hiding) overflowing elements with a position different from `initial`

export default function getClippingParent(element, offsetElement) {
  var scrollParent = getScrollParent(element);
  var offsetParent = offsetElement || getOffsetParent(element);
  var win = getWindow(element);
  return offsetParent === win ? getDocumentElement(element) : scrollParent.contains(offsetParent) ? scrollParent : getClippingParent(getScrollParent(getParentNode(scrollParent)), offsetParent);
}