import getBasePlacement from "../utils/getBasePlacement.js";
import { basePlacements, top, bottom, left, right } from "../enums.js";
export function distanceAndSkiddingToXY(placement, measures, getOffsets) {
  var basePlacement = getBasePlacement(placement);
  var invertDistance = [left, top].includes(basePlacement) ? -1 : 1;

  var _getOffsets = getOffsets(Object.assign({}, measures, {
    placement: placement
  })),
      distance = _getOffsets[0],
      skidding = _getOffsets[1];

  distance = (distance || 0) * invertDistance;
  skidding = skidding || 0;
  return [left, right].includes(basePlacement) ? [distance, skidding] : [skidding, distance];
}
export function offset(_ref) {
  var state = _ref.state,
      options = _ref.options;

  if (typeof options.offset === 'function') {
    var _distanceAndSkiddingT = distanceAndSkiddingToXY(state.placement, state.measures, options.offset),
        x = _distanceAndSkiddingT[0],
        y = _distanceAndSkiddingT[1]; // Add the offset to `detectOverflow`


    basePlacements.forEach(function (placement) {
      var isVertical = [top, bottom].includes(placement);
      var value = isVertical ? y : x;
      ['clippingArea', 'visibleArea'].forEach(function (property) {
        state.modifiersData.detectOverflow[property][placement] += value;
      });
    });
    state.modifiersData.popperOffsets.x += x;
    state.modifiersData.popperOffsets.y += y;
  }

  return state;
}
export default {
  name: 'offset',
  enabled: true,
  phase: 'main',
  requires: ['popperOffsets', 'detectOverflow'],
  fn: offset
};